diff --git a/src/backend/tsearch/ts_typanalyze.c b/src/backend/tsearch/ts_typanalyze.c
index 9771415..170d5ca 100644
--- a/src/backend/tsearch/ts_typanalyze.c
+++ b/src/backend/tsearch/ts_typanalyze.c
@@ -35,7 +35,8 @@ typedef struct
 	int			delta;			/* And this is 'delta'. */
 } TrackItem;
 
-static void compute_tsvector_stats(VacAttrStats *stats,
+static void compute_tsvector_stats(VacStats *stats,
+					   int index,
 					   AnalyzeAttrFetchFunc fetchfunc,
 					   int samplerows,
 					   double totalrows);
@@ -53,17 +54,21 @@ static int	trackitem_compare_lexemes(const void *e1, const void *e2);
 Datum
 ts_typanalyze(PG_FUNCTION_ARGS)
 {
-	VacAttrStats *stats = (VacAttrStats *) PG_GETARG_POINTER(0);
-	Form_pg_attribute attr = stats->attr;
+	VacStats *stats = (VacStats *) PG_GETARG_POINTER(0);
+	int4		i = PG_GETARG_INT32(1);
 
-	/* If the attstattarget column is negative, use the default value */
-	/* NB: it is okay to scribble on stats->attr since it's a copy */
-	if (attr->attstattarget < 0)
-		attr->attstattarget = default_statistics_target;
+	if (i < 0 || i >= STATISTIC_NUM_SLOTS)
+		PG_RETURN_BOOL(false);
 
-	stats->compute_stats = compute_tsvector_stats;
+	/* If the statarget column is negative, use the default value */
+	/* NB: it is okay to scribble on stats->statarget since it's a copy */
+	if (stats->statarget < 0)
+		stats->statarget = default_statistics_target;
+
+	stats->statfuncs[i].compute_func_ptr = compute_tsvector_stats;
+	stats->statfuncs[i].findval_func_ptr = NULL; /* this prevents cross-column stats to be computed */
 	/* see comment about the choice of minrows in commands/analyze.c */
-	stats->minrows = 300 * attr->attstattarget;
+	stats->minrows = 300 * stats->statarget;
 
 	PG_RETURN_BOOL(true);
 }
@@ -136,7 +141,8 @@ ts_typanalyze(PG_FUNCTION_ARGS)
  *	want.
  */
 static void
-compute_tsvector_stats(VacAttrStats *stats,
+compute_tsvector_stats(VacStats *stats,
+					   int index,
 					   AnalyzeAttrFetchFunc fetchfunc,
 					   int samplerows,
 					   double totalrows)
@@ -166,7 +172,7 @@ compute_tsvector_stats(VacAttrStats *stats,
 	 * the number of individual lexeme values tracked in pg_statistic ought to
 	 * be more than the number of values for a simple scalar column.
 	 */
-	num_mcelem = stats->attr->attstattarget * 10;
+	num_mcelem = stats->statarget * 10;
 
 	/*
 	 * We set bucket width equal to (num_mcelem + 10) / 0.007 as per the
@@ -206,7 +212,7 @@ compute_tsvector_stats(VacAttrStats *stats,
 
 		vacuum_delay_point();
 
-		value = fetchfunc(stats, vector_no, &isnull);
+		value = fetchfunc(stats, vector_no, stats->attnums->values[index], &isnull);
 
 		/*
 		 * Check for null/nonnull.
@@ -291,11 +297,11 @@ compute_tsvector_stats(VacAttrStats *stats,
 
 		stats->stats_valid = true;
 		/* Do the simple null-frac and average width stats */
-		stats->stanullfrac = (double) null_cnt / (double) samplerows;
-		stats->stawidth = total_width / (double) nonnull_cnt;
+		stats->stanullfrac[index] = (double) null_cnt / (double) samplerows;
+		stats->stawidth[index] = total_width / (double) nonnull_cnt;
 
 		/* Assume it's a unique column (see notes above) */
-		stats->stadistinct = -1.0;
+		stats->stadistinct[index] = -1.0;
 
 		/*
 		 * Construct an array of the interesting hashtable items, that is,
@@ -403,27 +409,27 @@ compute_tsvector_stats(VacAttrStats *stats,
 			mcelem_freqs[i] = (double) maxfreq / (double) nonnull_cnt;
 			MemoryContextSwitchTo(old_context);
 
-			stats->stakind[0] = STATISTIC_KIND_MCELEM;
-			stats->staop[0] = TextEqualOperator;
-			stats->stanumbers[0] = mcelem_freqs;
+			stats->stakind[index][0] = STATISTIC_KIND_MCELEM;
+			stats->staop[index][0] = TextEqualOperator;
+			stats->stanumbers[index][0] = mcelem_freqs;
 			/* See above comment about two extra frequency fields */
-			stats->numnumbers[0] = num_mcelem + 2;
-			stats->stavalues[0] = mcelem_values;
-			stats->numvalues[0] = num_mcelem;
+			stats->numnumbers[index][0] = num_mcelem + 2;
+			stats->stavalues[index][0] = mcelem_values;
+			stats->numvalues[index][0] = num_mcelem;
 			/* We are storing text values */
-			stats->statypid[0] = TEXTOID;
-			stats->statyplen[0] = -1;	/* typlen, -1 for varlena */
-			stats->statypbyval[0] = false;
-			stats->statypalign[0] = 'i';
+			stats->statypid[index][0] = TEXTOID;
+			stats->statyplen[index][0] = -1;	/* typlen, -1 for varlena */
+			stats->statypbyval[index][0] = false;
+			stats->statypalign[index][0] = 'i';
 		}
 	}
 	else
 	{
 		/* We found only nulls; assume the column is entirely null */
 		stats->stats_valid = true;
-		stats->stanullfrac = 1.0;
-		stats->stawidth = 0;	/* "unknown" */
-		stats->stadistinct = 0.0;		/* "unknown" */
+		stats->stanullfrac[index] = 1.0;
+		stats->stawidth[index] = 0;	/* "unknown" */
+		stats->stadistinct[index] = 0.0;		/* "unknown" */
 	}
 
 	/*
diff --git a/src/backend/utils/adt/array_typanalyze.c b/src/backend/utils/adt/array_typanalyze.c
index ba98739..4abc29e 100644
--- a/src/backend/utils/adt/array_typanalyze.c
+++ b/src/backend/utils/adt/array_typanalyze.c
@@ -50,7 +50,7 @@ typedef struct
 	FmgrInfo   *hash;
 
 	/* Saved state from std_typanalyze() */
-	AnalyzeAttrComputeStatsFunc std_compute_stats;
+	ComputeStatsFunc std_compute_stats;
 	void	   *std_extra_data;
 } ArrayAnalyzeExtraData;
 
@@ -78,7 +78,7 @@ typedef struct
 	int			frequency;		/* Number of arrays seen with this count */
 } DECountItem;
 
-static void compute_array_stats(VacAttrStats *stats,
+static void compute_array_stats(VacStats *stats, int index,
 		   AnalyzeAttrFetchFunc fetchfunc, int samplerows, double totalrows);
 static void prune_element_hashtable(HTAB *elements_tab, int b_current);
 static uint32 element_hash(const void *key, Size keysize);
@@ -95,7 +95,8 @@ static int	countitem_compare_count(const void *e1, const void *e2);
 Datum
 array_typanalyze(PG_FUNCTION_ARGS)
 {
-	VacAttrStats *stats = (VacAttrStats *) PG_GETARG_POINTER(0);
+	VacStats *stats = (VacStats *) PG_GETARG_POINTER(0);
+	int4 index = PG_GETARG_INT32(1);
 	Oid			element_typeid;
 	TypeCacheEntry *typentry;
 	ArrayAnalyzeExtraData *extra_data;
@@ -104,17 +105,17 @@ array_typanalyze(PG_FUNCTION_ARGS)
 	 * Call the standard typanalyze function.  It may fail to find needed
 	 * operators, in which case we also can't do anything, so just fail.
 	 */
-	if (!std_typanalyze(stats))
+	if (!std_typanalyze(stats, index))
 		PG_RETURN_BOOL(false);
 
 	/*
 	 * Check attribute data type is a varlena array.
 	 */
-	element_typeid = stats->attrtype->typelem;
+	element_typeid = stats->attrtypes[index]->typelem;
 
-	if (!OidIsValid(element_typeid) || stats->attrtype->typlen != -1)
+	if (!OidIsValid(element_typeid) || stats->attrtypes[index]->typlen != -1)
 		elog(ERROR, "array_typanalyze was invoked for non-array type %u",
-			 stats->attrtypid);
+			 stats->attrtypids[index]);
 
 	/*
 	 * Gather information about the element type.  If we fail to find
@@ -141,12 +142,12 @@ array_typanalyze(PG_FUNCTION_ARGS)
 	extra_data->hash = &typentry->hash_proc_finfo;
 
 	/* Save old compute_stats and extra_data for scalar statistics ... */
-	extra_data->std_compute_stats = stats->compute_stats;
-	extra_data->std_extra_data = stats->extra_data;
+	extra_data->std_compute_stats = stats->statfuncs[index].compute_func_ptr;
+	extra_data->std_extra_data = stats->extra_data[index];
 
 	/* ... and replace with our info */
-	stats->compute_stats = compute_array_stats;
-	stats->extra_data = extra_data;
+	stats->statfuncs[index].compute_func_ptr = compute_array_stats;
+	stats->extra_data[index] = extra_data;
 
 	/*
 	 * Note we leave stats->minrows set as std_typanalyze set it.  Should
@@ -211,7 +212,7 @@ array_typanalyze(PG_FUNCTION_ARGS)
  * We divide the raw counts by nonnull_cnt to get those figures.
  */
 static void
-compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
+compute_array_stats(VacStats *stats, int index, AnalyzeAttrFetchFunc fetchfunc,
 					int samplerows, double totalrows)
 {
 	ArrayAnalyzeExtraData *extra_data;
@@ -238,16 +239,16 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 	HASHCTL		count_hash_ctl;
 	DECountItem *count_item;
 
-	extra_data = (ArrayAnalyzeExtraData *) stats->extra_data;
+	extra_data = (ArrayAnalyzeExtraData *) stats->extra_data[index];
 
 	/*
 	 * Invoke analyze.c's standard analysis function to create scalar-style
 	 * stats for the column.  It will expect its own extra_data pointer,
 	 * so temporarily install that.
 	 */
-	stats->extra_data = extra_data->std_extra_data;
-	(*extra_data->std_compute_stats) (stats, fetchfunc, samplerows, totalrows);
-	stats->extra_data = extra_data;
+	stats->extra_data[index] = extra_data->std_extra_data;
+	(*extra_data->std_compute_stats) (stats, index, fetchfunc, samplerows, totalrows);
+	stats->extra_data[index] = extra_data;
 
 	/*
 	 * Set up static pointer for use by subroutines.  We wait till here in
@@ -262,7 +263,7 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 	 * the number of individual elements tracked in pg_statistic ought to be
 	 * more than the number of values for a simple scalar column.
 	 */
-	num_mcelem = stats->attr->attstattarget * 10;
+	num_mcelem = stats->statarget * 10;
 
 	/*
 	 * We set bucket width equal to num_mcelem / 0.007 as per the comment
@@ -318,7 +319,7 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 
 		vacuum_delay_point();
 
-		value = fetchfunc(stats, array_no, &isnull);
+		value = fetchfunc(stats, array_no, stats->attnums->values[index], &isnull);
 		if (isnull)
 		{
 			/* array is null, just count that */
@@ -437,7 +438,7 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 
 	/* Skip pg_statistic slots occupied by standard statistics */
 	slot_idx = 0;
-	while (slot_idx < STATISTIC_NUM_SLOTS && stats->stakind[slot_idx] != 0)
+	while (slot_idx < STATISTIC_NUM_SLOTS && stats->stakind[index][slot_idx] != 0)
 		slot_idx++;
 	if (slot_idx > STATISTIC_NUM_SLOTS - 2)
 		elog(ERROR, "insufficient pg_statistic slots for array stats");
@@ -558,18 +559,18 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 
 			MemoryContextSwitchTo(old_context);
 
-			stats->stakind[slot_idx] = STATISTIC_KIND_MCELEM;
-			stats->staop[slot_idx] = extra_data->eq_opr;
-			stats->stanumbers[slot_idx] = mcelem_freqs;
+			stats->stakind[index][slot_idx] = STATISTIC_KIND_MCELEM;
+			stats->staop[index][slot_idx] = extra_data->eq_opr;
+			stats->stanumbers[index][slot_idx] = mcelem_freqs;
 			/* See above comment about extra stanumber entries */
-			stats->numnumbers[slot_idx] = num_mcelem + 3;
-			stats->stavalues[slot_idx] = mcelem_values;
-			stats->numvalues[slot_idx] = num_mcelem;
+			stats->numnumbers[index][slot_idx] = num_mcelem + 3;
+			stats->stavalues[index][slot_idx] = mcelem_values;
+			stats->numvalues[index][slot_idx] = num_mcelem;
 			/* We are storing values of element type */
-			stats->statypid[slot_idx] = extra_data->type_id;
-			stats->statyplen[slot_idx] = extra_data->typlen;
-			stats->statypbyval[slot_idx] = extra_data->typbyval;
-			stats->statypalign[slot_idx] = extra_data->typalign;
+			stats->statypid[index][slot_idx] = extra_data->type_id;
+			stats->statyplen[index][slot_idx] = extra_data->typlen;
+			stats->statypbyval[index][slot_idx] = extra_data->typbyval;
+			stats->statypalign[index][slot_idx] = extra_data->typalign;
 			slot_idx++;
 		}
 
@@ -577,7 +578,7 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 		count_items_count = hash_get_num_entries(count_tab);
 		if (count_items_count > 0)
 		{
-			int			num_hist = stats->attr->attstattarget;
+			int			num_hist = stats->statarget;
 			DECountItem **sorted_count_items;
 			int			j;
 			int			delta;
@@ -659,10 +660,10 @@ compute_array_stats(VacAttrStats *stats, AnalyzeAttrFetchFunc fetchfunc,
 			}
 			Assert(j == count_items_count - 1);
 
-			stats->stakind[slot_idx] = STATISTIC_KIND_DECHIST;
-			stats->staop[slot_idx] = extra_data->eq_opr;
-			stats->stanumbers[slot_idx] = hist;
-			stats->numnumbers[slot_idx] = num_hist + 1;
+			stats->stakind[index][slot_idx] = STATISTIC_KIND_DECHIST;
+			stats->staop[index][slot_idx] = extra_data->eq_opr;
+			stats->stanumbers[index][slot_idx] = hist;
+			stats->numnumbers[index][slot_idx] = num_hist + 1;
 			slot_idx++;
 		}
 	}
diff --git a/src/backend/utils/adt/int.c b/src/backend/utils/adt/int.c
index a339abf..cb10dbe 100644
--- a/src/backend/utils/adt/int.c
+++ b/src/backend/utils/adt/int.c
@@ -254,21 +254,53 @@ int2vectorsend(PG_FUNCTION_ARGS)
 	return array_send(fcinfo);
 }
 
-/*
- * We don't have a complete set of int2vector support routines,
- * but we need int2vectoreq for catcache indexing.
- */
 Datum
 int2vectoreq(PG_FUNCTION_ARGS)
 {
-	int2vector *a = (int2vector *) PG_GETARG_POINTER(0);
-	int2vector *b = (int2vector *) PG_GETARG_POINTER(1);
+	int32		cmp = DatumGetInt32(btint2vectorcmp(fcinfo));
 
-	if (a->dim1 != b->dim1)
-		PG_RETURN_BOOL(false);
-	PG_RETURN_BOOL(memcmp(a->values, b->values, a->dim1 * sizeof(int2)) == 0);
+	PG_RETURN_BOOL(cmp == 0);
+}
+
+Datum
+int2vectorne(PG_FUNCTION_ARGS)
+{
+	int32		cmp = DatumGetInt32(btint2vectorcmp(fcinfo));
+
+	PG_RETURN_BOOL(cmp != 0);
 }
 
+Datum
+int2vectorlt(PG_FUNCTION_ARGS)
+{
+	int32		cmp = DatumGetInt32(btint2vectorcmp(fcinfo));
+
+	PG_RETURN_BOOL(cmp < 0);
+}
+
+Datum
+int2vectorle(PG_FUNCTION_ARGS)
+{
+	int32		cmp = DatumGetInt32(btint2vectorcmp(fcinfo));
+
+	PG_RETURN_BOOL(cmp <= 0);
+}
+
+Datum
+int2vectorge(PG_FUNCTION_ARGS)
+{
+	int32		cmp = DatumGetInt32(btint2vectorcmp(fcinfo));
+
+	PG_RETURN_BOOL(cmp >= 0);
+}
+
+Datum
+int2vectorgt(PG_FUNCTION_ARGS)
+{
+	int32		cmp = DatumGetInt32(btint2vectorcmp(fcinfo));
+
+	PG_RETURN_BOOL(cmp > 0);
+}
 
 /*****************************************************************************
  *	 PUBLIC ROUTINES														 *
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index 382cd73..34db4a6 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -94,6 +94,7 @@
 #include "access/gin.h"
 #include "access/sysattr.h"
 #include "catalog/index.h"
+#include "catalog/indexing.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_opfamily.h"
 #include "catalog/pg_statistic.h"
@@ -112,6 +113,7 @@
 #include "optimizer/var.h"
 #include "parser/parse_clause.h"
 #include "parser/parse_coerce.h"
+#include "parser/parse_utilcmd.h"
 #include "parser/parsetree.h"
 #include "utils/builtins.h"
 #include "utils/bytea.h"
@@ -4140,6 +4142,34 @@ get_join_variables(PlannerInfo *root, List *args, SpecialJoinInfo *sjinfo,
 }
 
 /*
+ * validate_statistics -- sets vardata->statsTuple only if the statistics is valid
+ */
+void
+validate_statistics(VariableStatData *vardata,
+			Oid relid, AttrNumber *attnums, int n_attnums, bool inherited)
+{
+	int2vector *attnumvector = buildint2vector(attnums, n_attnums);
+	HeapTuple	tuple;
+
+	tuple = SearchSysCache3(STATRELATTINH,
+									ObjectIdGetDatum(relid),
+									PointerGetDatum(attnumvector),
+									  BoolGetDatum(inherited));
+	pfree(attnumvector);
+
+	if (HeapTupleIsValid(tuple))
+	{
+		if (((Form_pg_statistic) GETSTRUCT(tuple))->stavalid)
+		{
+			vardata->statsTuple = tuple;
+			vardata->freefunc = ReleaseSysCache;
+		}
+		else
+			ReleaseSysCache(tuple);
+	}
+}
+
+/*
  * examine_variable
  *		Try to look up statistical data about an expression.
  *		Fill in a VariableStatData struct to describe the expression.
@@ -4177,6 +4207,7 @@ examine_variable(PlannerInfo *root, Node *node, int varRelid,
 {
 	Node	   *basenode;
 	Relids		varnos;
+	int		onerelid = 0;
 	RelOptInfo *onerel;
 
 	/* Make sure we don't return dangling pointers in vardata */
@@ -4229,8 +4260,8 @@ examine_variable(PlannerInfo *root, Node *node, int varRelid,
 		case BMS_SINGLETON:
 			if (varRelid == 0 || bms_is_member(varRelid, varnos))
 			{
-				onerel = find_base_rel(root,
-					   (varRelid ? varRelid : bms_singleton_member(varnos)));
+				onerelid = (varRelid ? varRelid : bms_singleton_member(varnos));
+				onerel = find_base_rel(root, onerelid);
 				vardata->rel = onerel;
 				node = basenode;	/* strip any relabeling */
 			}
@@ -4264,15 +4295,82 @@ examine_variable(PlannerInfo *root, Node *node, int varRelid,
 	{
 		/*
 		 * We have an expression in vars of a single relation.	Try to match
-		 * it to expressional index columns, in hopes of finding some
-		 * statistics.
+		 * it to expression statistics first then to expressional index columns,
+		 * in hopes of finding some statistics.
 		 *
 		 * XXX it's conceivable that there are multiple matches with different
 		 * index opfamilies; if so, we need to pick one that matches the
 		 * operator we are estimating for.	FIXME later.
 		 */
 		ListCell   *ilist;
+		Node	   *expr = copyObject(node);
+		char	   *exprbin;
+		Datum		exprbindatum;
+
+#if 0
+#define USE_SYSCACHE_FOR_SEARCH	0
+#if !USE_SYSCACHE_FOR_SEARCH
+		Relation	rel;
+		ScanKeyData	scanKey[2];  
+		SysScanDesc	scan;
+		HeapTuple	tuple;
+#endif
+#endif
+
+		/* FIXME:
+		 * query_or_expression_tree_walker(expr, set_location_unknown_walker, NULL, 0);*/
+		exprbin = nodeToString(expr);
+		exprbindatum = CStringGetTextDatum(exprbin);
+
+#if 0
+#if USE_SYSCACHE_FOR_SEARCH
+		vardata->statsTuple = SearchSysCache3(STAT3RELEXPRINH,
+								ObjectIdGetDatum(root->simple_rte_array[onerelid]->relid),
+								exprbindatum,
+								BoolGetDatum(false));
+		if (HeapTupleIsValid(vardata->statsTuple))
+		{
+			vardata->stats_type = STAT_EXPRESSION;
+			vardata->freefunc = ReleaseSysCache;
+			return;
+		}
 
+#else
+
+		rel = heap_open(StatisticRelationId, RowShareLock);
+
+		ScanKeyInit(&scanKey[0],
+							Anum_pg_statistic3_sta3relid,
+							BTEqualStrategyNumber, F_OIDEQ,
+							ObjectIdGetDatum(root->simple_rte_array[onerelid]->relid));
+		ScanKeyInit(&scanKey[1],
+							Anum_pg_statistic3_sta3expr,
+							BTEqualStrategyNumber, F_TEXTEQ,
+							exprbindatum);
+
+		scan = systable_beginscan(rel, Statistic3RelidExprInhIndexId, true,
+							SnapshotNow, 2, scanKey);
+
+		tuple = systable_getnext(scan);
+		if (HeapTupleIsValid(tuple))
+		{
+//			elog(NOTICE, "examine_variable expression found");
+			vardata->stats_type = STAT_EXPRESSION;
+			vardata->statsTuple = heap_copytuple(tuple);
+			vardata->freefunc = heap_freetuple;
+		}
+
+		systable_endscan(scan);
+
+		pfree(exprbin);
+		pfree(DatumGetPointer(exprbindatum));
+
+		relation_close(rel, RowShareLock);
+
+		if (vardata->statsTuple)
+			return;
+#endif
+#endif
 		foreach(ilist, onerel->indexlist)
 		{
 			IndexOptInfo *index = (IndexOptInfo *) lfirst(ilist);
@@ -4330,12 +4428,9 @@ examine_variable(PlannerInfo *root, Node *node, int varRelid,
 						}
 						else if (index->indpred == NIL)
 						{
-							vardata->statsTuple =
-								SearchSysCache3(STATRELATTINH,
-										   ObjectIdGetDatum(index->indexoid),
-												Int16GetDatum(pos + 1),
-												BoolGetDatum(false));
-							vardata->freefunc = ReleaseSysCache;
+							int2		attnum = pos + 1;
+
+							validate_statistics(vardata, index->indexoid, &attnum, 1, false);
 						}
 						if (vardata->statsTuple)
 							break;
@@ -4383,11 +4478,7 @@ examine_simple_variable(PlannerInfo *root, Var *var,
 		 * Plain table or parent of an inheritance appendrel, so look up the
 		 * column in pg_statistic
 		 */
-		vardata->statsTuple = SearchSysCache3(STATRELATTINH,
-											  ObjectIdGetDatum(rte->relid),
-											  Int16GetDatum(var->varattno),
-											  BoolGetDatum(rte->inh));
-		vardata->freefunc = ReleaseSysCache;
+		validate_statistics(vardata, rte->relid, &(var->varattno), 1, rte->inh);
 	}
 	else if (rte->rtekind == RTE_SUBQUERY && !rte->inh)
 	{
@@ -6514,13 +6605,7 @@ btcostestimate(PG_FUNCTION_ARGS)
 				elog(ERROR, "no function provided to release variable stats with");
 		}
 		else
-		{
-			vardata.statsTuple = SearchSysCache3(STATRELATTINH,
-												 ObjectIdGetDatum(relid),
-												 Int16GetDatum(colnum),
-												 BoolGetDatum(rte->inh));
-			vardata.freefunc = ReleaseSysCache;
-		}
+			validate_statistics(&vardata, relid, &colnum, 1, rte->inh);
 	}
 	else
 	{
@@ -6540,13 +6625,7 @@ btcostestimate(PG_FUNCTION_ARGS)
 				elog(ERROR, "no function provided to release variable stats with");
 		}
 		else
-		{
-			vardata.statsTuple = SearchSysCache3(STATRELATTINH,
-												 ObjectIdGetDatum(relid),
-												 Int16GetDatum(colnum),
-												 BoolGetDatum(false));
-			vardata.freefunc = ReleaseSysCache;
-		}
+			validate_statistics(&vardata, relid, &colnum, 1, false);
 	}
 
 	if (HeapTupleIsValid(vardata.statsTuple))
diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index 44dab82..6391d92 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -2674,6 +2674,7 @@ get_attavgwidth(Oid relid, AttrNumber attnum)
 {
 	HeapTuple	tp;
 	int32		stawidth;
+	int2vector *attnumvector = NULL;
 
 	if (get_attavgwidth_hook)
 	{
@@ -2681,10 +2682,12 @@ get_attavgwidth(Oid relid, AttrNumber attnum)
 		if (stawidth > 0)
 			return stawidth;
 	}
+	attnumvector = buildint2vector(&attnum, 1);
 	tp = SearchSysCache3(STATRELATTINH,
 						 ObjectIdGetDatum(relid),
-						 Int16GetDatum(attnum),
+						 PointerGetDatum(attnumvector),
 						 BoolGetDatum(false));
+	pfree(attnumvector);
 	if (HeapTupleIsValid(tp))
 	{
 		stawidth = ((Form_pg_statistic) GETSTRUCT(tp))->stawidth;
@@ -2735,7 +2738,7 @@ get_attstatsslot(HeapTuple statstuple,
 				 Datum **values, int *nvalues,
 				 float4 **numbers, int *nnumbers)
 {
-	Form_pg_statistic stats = (Form_pg_statistic) GETSTRUCT(statstuple);
+	Form_pg_statistic stats;
 	int			i,
 				j;
 	Datum		val;
@@ -2746,12 +2749,15 @@ get_attstatsslot(HeapTuple statstuple,
 	HeapTuple	typeTuple;
 	Form_pg_type typeForm;
 
+	stats = (Form_pg_statistic) GETSTRUCT(statstuple);
+
 	for (i = 0; i < STATISTIC_NUM_SLOTS; i++)
 	{
 		if ((&stats->stakind1)[i] == reqkind &&
 			(reqop == InvalidOid || (&stats->staop1)[i] == reqop))
 			break;
 	}
+
 	if (i >= STATISTIC_NUM_SLOTS)
 		return false;			/* not there */
 
@@ -2763,8 +2769,9 @@ get_attstatsslot(HeapTuple statstuple,
 		val = SysCacheGetAttr(STATRELATTINH, statstuple,
 							  Anum_pg_statistic_stavalues1 + i,
 							  &isnull);
+		/* invalid stats record, i.e. analyze hasn't yet run for this column */
 		if (isnull)
-			elog(ERROR, "stavalues is null");
+			return false;
 		statarray = DatumGetArrayTypeP(val);
 
 		/*
@@ -2817,8 +2824,9 @@ get_attstatsslot(HeapTuple statstuple,
 		val = SysCacheGetAttr(STATRELATTINH, statstuple,
 							  Anum_pg_statistic_stanumbers1 + i,
 							  &isnull);
+		/* invalid stats record, i.e. analyze hasn't yet run for this column */
 		if (isnull)
-			elog(ERROR, "stanumbers is null");
+			return false;
 		statarray = DatumGetArrayTypeP(val);
 
 		/*
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index a59950e..9da6ed8 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -4333,6 +4333,7 @@ write_relcache_init_file(bool shared)
 		write_item(relform, CLASS_TUPLE_SIZE, fp);
 
 		/* next, do all the attribute tuple form data entries */
+		elog(LOG, "write_relcache_init_file relname '%s' relnatts %d", NameStr(relform->relname), relform->relnatts);
 		for (i = 0; i < relform->relnatts; i++)
 		{
 			write_item(rel->rd_att->attrs[i], ATTRIBUTE_FIXED_PART_SIZE, fp);
diff --git a/src/backend/utils/cache/syscache.c b/src/backend/utils/cache/syscache.c
index 78ce0b8..f7c1ba0 100644
--- a/src/backend/utils/cache/syscache.c
+++ b/src/backend/utils/cache/syscache.c
@@ -600,11 +600,11 @@ static const struct cachedesc cacheinfo[] = {
 		1024
 	},
 	{StatisticRelationId,		/* STATRELATTINH */
-		StatisticRelidAttnumInhIndexId,
+		StatisticRelidAttnumsInhIndexId,
 		3,
 		{
 			Anum_pg_statistic_starelid,
-			Anum_pg_statistic_staattnum,
+			Anum_pg_statistic_staattnums,
 			Anum_pg_statistic_stainherit,
 			0
 		},
diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index 99cf5b4..bb95a6d 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -119,6 +119,12 @@ static bool noclean = false;
 static bool show_setting = false;
 static char *xlog_dir = "";
 
+#ifdef DEVNULL
+#undef DEVNULL
+#endif
+#define DEVNULL	"/tmp/initdb.log"
+
+#define DEVNULLINPUT	"/dev/zero"
 
 /* internal vars */
 static const char *progname;
@@ -165,7 +171,7 @@ static char *authwarning = NULL;
  * (no quoting to worry about).
  */
 static const char *boot_options = "-F";
-static const char *backend_options = "--single -F -O -c search_path=pg_catalog -c exit_on_error=true";
+static const char *backend_options = "--single -F -O -c search_path=pg_catalog -c exit_on_error=true -c log_min_messages=warning -c log_min_error_statement=info ";
 
 
 /* path to 'initdb' binary directory */
@@ -924,7 +930,7 @@ test_config_settings(void)
 				 "< \"%s\" > \"%s\" 2>&1" SYSTEMQUOTE,
 				 backend_exec, boot_options,
 				 test_conns, test_buffs,
-				 DEVNULL, DEVNULL);
+				 DEVNULLINPUT, DEVNULL);
 		status = system(cmd);
 		if (status == 0)
 		{
@@ -958,7 +964,7 @@ test_config_settings(void)
 				 "< \"%s\" > \"%s\" 2>&1" SYSTEMQUOTE,
 				 backend_exec, boot_options,
 				 n_connections, test_buffs,
-				 DEVNULL, DEVNULL);
+				 DEVNULLINPUT, DEVNULL);
 		status = system(cmd);
 		if (status == 0)
 			break;
@@ -1273,7 +1279,7 @@ setup_auth(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1351,7 +1357,7 @@ get_set_pwd(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1451,7 +1457,7 @@ setup_depend(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1484,7 +1490,7 @@ setup_sysviews(void)
 	 * We use -j here to avoid backslashing stuff in system_views.sql
 	 */
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s -j template1 >%s",
+			 "\"%s\" %s -j template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1515,7 +1521,7 @@ setup_description(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1622,7 +1628,7 @@ setup_collation(void)
 
 #if defined(HAVE_LOCALE_T) && !defined(WIN32)
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1761,7 +1767,7 @@ setup_conversion(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1799,7 +1805,7 @@ setup_dictionary(void)
 	 * We use -j here to avoid backslashing stuff
 	 */
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s -j template1 >%s",
+			 "\"%s\" %s -j template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1850,7 +1856,7 @@ setup_privileges(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1913,7 +1919,7 @@ setup_schema(void)
 	 * We use -j here to avoid backslashing stuff in information_schema.sql
 	 */
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s -j template1 >%s",
+			 "\"%s\" %s -j template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1930,7 +1936,7 @@ setup_schema(void)
 	PG_CMD_CLOSE;
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1964,7 +1970,7 @@ load_plpgsql(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -1989,7 +1995,7 @@ vacuum_db(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -2045,7 +2051,7 @@ make_template0(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
@@ -2077,7 +2083,7 @@ make_postgres(void)
 	fflush(stdout);
 
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s\" %s template1 >%s",
+			 "\"%s\" %s template1 >>%s 2>&1",
 			 backend_exec, backend_options,
 			 DEVNULL);
 
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index 4eee4be..42153de 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -1300,7 +1300,8 @@ describeOneTableDetails(const char *schemaname,
 	if (verbose)
 	{
 		appendPQExpBuffer(&buf, ",\n  a.attstorage");
-		appendPQExpBuffer(&buf, ",\n  CASE WHEN a.attstattarget=-1 THEN NULL ELSE a.attstattarget END AS attstattarget");
+		/* FIXME: need stat target value here*/
+		appendPQExpBuffer(&buf, ",\n  NULL AS attstattarget");
 		/*
 		 * In 9.0+, we have column comments for: relations, views, composite
 		 * types, and foreign tables (c.f. CommentObject() in comment.c).
diff --git a/src/include/catalog/heap.h b/src/include/catalog/heap.h
index 2055382..b0a3009 100644
--- a/src/include/catalog/heap.h
+++ b/src/include/catalog/heap.h
@@ -109,7 +109,12 @@ extern void RemoveAttributeById(Oid relid, AttrNumber attnum);
 extern void RemoveAttrDefault(Oid relid, AttrNumber attnum,
 				  DropBehavior behavior, bool complain, bool internal);
 extern void RemoveAttrDefaultById(Oid attrdefId);
-extern void RemoveStatistics(Oid relid, AttrNumber attnum);
+extern void AddStatistics(Oid relid, AttrNumber *attnums,
+						  int n_attnums,
+						  bool inherited,
+						  int statistics_target);
+extern void InvalidateStatistics(Oid relid, AttrNumber attnum);
+extern void RemoveStatistics(Oid relid, AttrNumber *attnums, int n_attnums);
 
 extern Form_pg_attribute SystemAttributeDefinition(AttrNumber attno,
 						  bool relhasoids);
diff --git a/src/include/catalog/indexing.h b/src/include/catalog/indexing.h
index 450ec25..90a5c7b 100644
--- a/src/include/catalog/indexing.h
+++ b/src/include/catalog/indexing.h
@@ -218,8 +218,8 @@ DECLARE_INDEX(pg_shdepend_depender_index, 1232, on pg_shdepend using btree(dbid
 DECLARE_INDEX(pg_shdepend_reference_index, 1233, on pg_shdepend using btree(refclassid oid_ops, refobjid oid_ops));
 #define SharedDependReferenceIndexId	1233
 
-DECLARE_UNIQUE_INDEX(pg_statistic_relid_att_inh_index, 2696, on pg_statistic using btree(starelid oid_ops, staattnum int2_ops, stainherit bool_ops));
-#define StatisticRelidAttnumInhIndexId	2696
+DECLARE_UNIQUE_INDEX(pg_statistic_relid_att_inh_index, 2696, on pg_statistic using btree(starelid oid_ops, staattnums int2vector_ops, stainherit bool_ops));
+#define StatisticRelidAttnumsInhIndexId	2696
 
 DECLARE_UNIQUE_INDEX(pg_tablespace_oid_index, 2697, on pg_tablespace using btree(oid oid_ops));
 #define TablespaceOidIndexId  2697
diff --git a/src/include/catalog/pg_amop.h b/src/include/catalog/pg_amop.h
index 82391b0..b6d9cd6 100644
--- a/src/include/catalog/pg_amop.h
+++ b/src/include/catalog/pg_amop.h
@@ -185,6 +185,16 @@ DATA(insert (	1991   30 30 4 s	648 403 0 ));
 DATA(insert (	1991   30 30 5 s	646 403 0 ));
 
 /*
+ *	btree int2vector_ops
+ */
+
+DATA(insert (	3171   22 22 1 s   3166 403 0 ));
+DATA(insert (	3171   22 22 2 s   3169 403 0 ));
+DATA(insert (	3171   22 22 3 s	386 403 0 ));
+DATA(insert (	3171   22 22 4 s   3170 403 0 ));
+DATA(insert (	3171   22 22 5 s   3167 403 0 ));
+
+/*
  *	btree float_ops
  */
 
